## norm 1.5.8+dfsg2

=== wscript ===
#!/usr/bin/env  
'''
wscript - Waf build script for NORM
See http://waf.googlecode.com/ for more information.

In order to use different build directories (for example, a release and a debug
build), use the -o (--out) flag when configuring.  For example:

    ./waf configure -o build-debug --debug
    ./waf

    ./waf configure -o build-release
    ./waf
    
To build examples, use the --target directive.  For example:

    ./waf build --target=normClient,normServer

'''

import platform

import waflib

# Fetch VERSION from include/normVersion.h file
VERSION = None
vfile = open('include/normVersion.h', 'r')
for line in vfile.readlines():
    line = line.split()
    if len(line) != 3:
        continue
    if "#define" == line[0] and "VERSION" == line[1]:
        VERSION = line[2].strip('"')
if VERSION is None:
    print "Warning: NORM VERSION not found!?"

# So you don't need to do ./waf configure if you are just using the defaults
waflib.Configure.autoconfig = True

# Top-level project directory
top = '.'
# Directory where build files are placed
out = 'build'

# System waf is running on: linux, darwin (Mac OSX), freebsd, windows, etc.
system = platform.system().lower()

def options(ctx):
    ctx.recurse('protolib')    
    build_opts = ctx.parser.add_option_group('Compile/install Options', 'Use during build/install step.')
    build_opts.add_option('--enable-static-library', action='store_true',
            help='Enable building and installing static library. [default:false]')


def configure(ctx):
    ctx.recurse('protolib')

    # Use this USE variable to add flags to NORM's compilation
    ctx.env.USE_BUILD_NORM += ['BUILD_NORM', 'protolib']

    if system in ('linux', 'darwin', 'freebsd', 'gnu', 'gnu/kfreebsd'):
        ctx.env.DEFINES_BUILD_NORM += ['ECN_SUPPORT']

    if system == 'windows':
        ctx.env.DEFINES_BUILD_NORM += ['NORM_USE_DLL']

    if ctx.env.COMPILER_CXX == 'g++' or ctx.env.COMPILER_CXX == 'clang++':
        ctx.env.CFLAGS += ['-fvisibility=hidden']
        ctx.env.CXXFLAGS += ['-fvisibility=hidden']

def build(ctx):
    ctx.recurse('protolib')
    
    # Setup to install NORM header file
    ctx.install_files("${PREFIX}/include/", "include/normApi.h")
    
    ctx.objects(
        target = 'objs',
        includes = ['include'],
        export_includes = ['include'],
        use = ctx.env.USE_BUILD_NORM,
        stlib = ["protolib"],
        source = ['src/common/{0}.cpp'.format(x) for x in [
            'galois',
            'normApi',
            'normEncoder',
            'normEncoderMDP',
            'normEncoderRS16',
            'normEncoderRS8',
            'normFile',
            'normMessage',
            'normNode',
            'normObject',
            'normSegment',
            'normSession',
        ]],
    )
    
	# Use static lib for Unix examples for convenience
	# (so we don't have to worry about LD_LIBRARY_PATH)
    ctx.shlib(
        target = 'norm',
        includes = ['include'],
        export_includes = ['include'],
        vnum = VERSION,
        stlib = ["protolib"],
        use = ['objs'] + ctx.env.USE_BUILD_NORM,
        source = [],
        features = 'cxx cxxshlib',
    )

    if ctx.options.enable_static_library:
        ctx.stlib(
            target = 'norm',
            includes = ['include'],
            export_includes = ['include'],
            vnum = VERSION,
            stlib = ["protolib"],
            use = ['objs'] + ctx.env.USE_BUILD_NORM,
            source = [],
            features = 'cxx cxxstlib',
            install_path = '${LIBDIR}',
        )

    if ctx.env.BUILD_PYTHON:
        ctx(
            features='py',
            source=ctx.path.ant_glob('src/pynorm/**/*.py'),
            install_from='src',
        )

    if ctx.env.BUILD_JAVA:
        ctx.shlib(
            target = 'mil_navy_nrl_norm',
            use = ['norm_shlib', 'JAVA'],
		    vnum = VERSION,
            source = ['src/java/jni/{0}.cpp'.format(x) for x in [
                'normJni',
                'normInstanceJni',
                'normSessionJni',
                'normObjectJni',
                'normDataJni',
                'normFileJni',
                'normStreamJni',
                'normEventJni',
                'normNodeJni',
            ]],
        )
        ctx(
            features = ['javac', 'jar'],
            srcdir = 'src/java/src',
            outdir = 'src/java/src',
            basedir = 'src/java/src',
            destfile = 'norm.jar',
        )

    normapp = ctx.program(
        # Need to explicitly set a different name, because 
        # the  library is also named "norm"
        name = 'normapp',
        target = 'normapp',
        use = ['protolib', 'norm_stlib'],
        defines = [],
        source = ['src/common/{0}'.format(x) for x in [
            'normPostProcess.cpp',
            'normApp.cpp',
        ]],
        # Disabled by default
        posted = True,
    )

    if system in ('linux', 'darwin', 'freebsd', 'gnu', 'gnu/kfreebsd'):
        normapp.source.append('src/unix/unixPostProcess.cpp')

    if system == 'windows':
        normapp.source.append('src/win32/win32PostProcess.cpp')
        normapp.defines.append('_CONSOLE')
        normapp.stlib = (["Shell32"]);

    for example in (
            'normDataExample',
            'normDataRecv',
            'normDataSend',
            'normFileRecv',
            'normFileSend',
            'normStreamRecv',
            'normStreamSend',
            'normMsgr',
            'normStreamer',
            'normClient',
            'normServer',
            'wintest'
            ):
        _make_simple_example(ctx, example)

    for prog in (
            'fecTest',
            'normPrecode',
            'normTest',
            'normThreadTest',
            'raft',
            ):
        _make_simple_example(ctx, prog, 'src/common')

    # Enable example targets specified on the command line
    ctx._parse_targets()

def _make_simple_example(ctx, name, path='examples'):
    '''Makes a task from a single source file in the examples directory.

    Note these tasks are not built by default.  Use the --targets flag.
    '''
    source = ['{0}/{1}.cpp'.format(path, name)]
    if 'normClient' == name or 'normServer' == name:
        source.append('%s/normSocket.cpp' % path)
    example = ctx.program(
        target = name,
        use = ['protolib'],
        defines = [],
        source = source,
        # Don't build examples by default
        posted = True,
        # Don't install examples
        install_path = False,
    )
    if 'windows' == system:
        example.use.append('norm_shlib')
        example.defines.append('_CONSOLE')
    else:
        example.use.append('norm_stlib')

=== protolib/wscript ===
#!/usr/bin/env python
'''
wscript - Waf build script for Protolib
See http://waf.googlecode.com/ for more information.

In order to use different build directories (for example, a release and a debug
build), use the -o (--out) flag when configuring.  For example:

    ./waf configure -o build-debug --debug
    ./waf

    ./waf configure -o build-release
    ./waf

'''

import platform

import waflib

# So you don't need to do ./waf configure if you are just using the defaults
waflib.Configure.autoconfig = True

# Top-level project directory
top = '.'
# Directory where build files are placed
out = 'build'

# System waf is running on: linux, darwin (Mac OSX), freebsd, windows, etc.
system = platform.system().lower()

def options(ctx):
    ctx.load('compiler_cxx')
    ctx.load('python')
    ctx.load('java')

    bind_opts = ctx.parser.add_option_group('Language Bindings', 'Use during configure step.')
    bind_opts.add_option('--build-python', action='store_true',
            help='Build Python bindings [default:false]')
    bind_opts.add_option('--build-java', action='store_true',
            help='Build Java bindings [default:false]')

    build_opts = ctx.parser.add_option_group('Compile Options', 'Use during build step.')
    build_opts.add_option('--debug', action='store_true',
            help='Build in debug mode [default:release]')
    build_opts.add_option('--enable-wx', action='store_true',
            help='Enable checking for wxWidgets.')
    build_opts.add_option('--enable-static-library', action='store_true',
            help='Enable installing static library. [default:false]')

def configure(ctx):
    if system == 'windows':
        ctx.env.MSVC_TARGETS = ['x86']

    ctx.load('compiler_cxx')

    # Use this USE variable to add flags to protolib's compilation
    ctx.env.USE_BUILD_PROTOLIB += ['BUILD_PROTOLIB']

    if system in ('linux', 'darwin', 'freebsd', 'gnu', 'gnu/kfreebsd'):
        ctx.env.DEFINES_BUILD_PROTOLIB += ['UNIX', 'HAVE_DIRFD', 'HAVE_IPV6',
                'HAVE_ASSERT', 'HAVE_GETLOGIN']

        ctx.check_cxx(lib='pthread')
        ctx.env.USE_BUILD_PROTOLIB += ['PTHREAD']

        if ctx.options.enable_wx:
            ctx.check_cfg(path='wx-config', args=['--cxxflags', '--libs'],
                    package='', uselib_store='WX', mandatory=False)

    if system == 'linux':
        ctx.env.DEFINES_BUILD_PROTOLIB += ['LINUX', 
                'HAVE_LOCKF', '_FILE_OFFSET_BITS=64', 'HAVE_OLD_SIGNALHANDLER', 
                'NO_SCM_RIGHTS', 'HAVE_SCHED',  
                'USE_TIMERFD', 'USE_EVENTFD', 'HAVE_PSELECT', 'USE_SELECT']
        ctx.check_cxx(lib='dl rt')
        ctx.env.USE_BUILD_PROTOLIB += ['DL', 'RT']

        ctx.env.HAVE_NETFILTER_QUEUE = ctx.check_cxx(lib='netfilter_queue',
                mandatory=False)

    if system == 'darwin':
        ctx.env.DEFINES_BUILD_PROTOLIB += ['MACOSX',
                'HAVE_FLOCK', '_FILE_OFFSET_BITS=64', 'HAVE_PSELECT', 'USE_SELECT']
        ctx.check_cxx(lib='resolv')
        ctx.env.USE_BUILD_PROTOLIB += ['RESOLV']

    if system in ('freebsd'):
        ctx.env.DEFINES_BUILD_PROTOLIB += ['HAVE_FLOCK', '_FILE_OFFSET_BITS=64', 
                                           'HAVE_PSELECT', 'USE_SELECT']

    if system == 'windows':
        ctx.env.DEFINES_BUILD_PROTOLIB += ['_CRT_SECURE_NO_WARNINGS',
                'HAVE_ASSERT', 'WIN32', 'HAVE_IPV6']
        ctx.env.CXXFLAGS += ['/EHsc']
        ctx.check_libs_msvc(['ws2_32', 'iphlpapi', 'user32', 'gdi32', 'Advapi32', 'ntdll'])
        ctx.env.USE_BUILD_PROTOLIB += ['WS2_32', 'IPHLPAPI', 'USER32', 'GDI32', 'ADVAPI32', 'ntdll.lib']
        
    if system == "gnu":
        ctx.check_cxx(lib='pcap')
        ctx.env.LDFLAGS += ['-lpcap']

    if ctx.options.build_python:
        ctx.load('python')
        ctx.check_python_version((2,4))
        ctx.check_python_headers()
        if ctx.env.PYTHON_VERSION.split('.')[0] != '2':
            waflib.Logs.warn('Python bindings currently only support Python 2')
            ctx.env.BUILD_PYTHON = False
        else:
            ctx.env.BUILD_PYTHON = True

    if ctx.options.build_java:
        ctx.load('java')
        ctx.check_jni_headers()
        for i in ctx.env.DEFINES:
            if i == 'HAVE_JNI_H=1':
                ctx.env.BUILD_JAVA = True

    # Compiler-specific flags
    if ctx.options.debug:
        #ctx.env.DEFINES_BUILD_PROTOLIB += ['PROTO_DEBUG', 'DEBUG', '_DEBUG']
		ctx.env.DEFINES_BUILD_PROTOLIB += ['PROTO_DEBUG', 'DEBUG']
    else:
        ctx.env.DEFINES_BUILD_PROTOLIB += ['NDEBUG', "PROTO_DEBUG"]

    if ctx.env.COMPILER_CXX == 'g++' or ctx.env.COMPILER_CXX == 'clang++':
        ctx.env.CFLAGS += ['-fPIC']
        ctx.env.CXXFLAGS += ['-fPIC']
        if ctx.options.debug:
            ctx.env.CFLAGS += ['-O0', '-g']
            ctx.env.CXXFLAGS += ['-O0', '-g']
        else:
            ctx.env.CFLAGS += ['-O3']
            ctx.env.CXXFLAGS += ['-O3']

    if ctx.env.COMPILER_CXX == 'msvc':
        if ctx.options.debug:
            ctx.env.CFLAGS += ['/Od', '/RTC1', '/ZI']
        else:
            ctx.env.CXXFLAGS += ['/Ox', '/DNDEBUG']
        	#ctx.env.CXXFLAGS += ['/Ox', '/DNDEBUG', '/DWINVER=0x0501']
        ctx.env.CFLAGS

def build(ctx):
    protolib = ctx.stlib(
        target = 'protolib',
        includes = ['include', 'include/unix'],
        export_includes = ['include', 'include/unix'],
        use = ctx.env.USE_BUILD_PROTOLIB,
        source = ['src/common/{0}.cpp'.format(x) for x in [
            'protoAddress',
            'protoApp',
            'protoBase64',
            'protoBitmask',
            'protoCap',
            'protoChannel',
            'protoDebug',
            'protoDispatcher',
            'protoEvent',
            'protoGraph',
            'protoJson',
            'protoLFSR',
            'protoList',
            'protoNet',
            'protoPipe',
            'protoPkt',
            'protoPktARP',
            'protoPktETH',
            'protoPktIP',
            'protoPktRTP',
            'protoQueue',
            'protoRouteMgr',
            'protoRouteTable',
            'protoSerial',
            'protoSocket',
            'protoSpace',
            'protoString',
            'protoTime',
            'protoTimer',
            'protoTree',
            'protoVif',
        ]],
        install_path = '${LIBDIR}' if ctx.options.enable_static_library else '',
    )

    if system in ('linux', 'darwin', 'freebsd', 'gnu', 'gnu/kfreebsd'):
        protolib.source.extend(['src/unix/{0}.cpp'.format(x) for x in [
            'unixNet',
            'unixSerial',
            'unixVif',
        ]])
        protolib.source.extend(['src/manet/{0}.cpp'.format(x) for x in [
            'manetGraph',
            'manetMsg',
        ]])
        protolib.source.append('src/common/protoFile.cpp')

    if system == 'linux':
        protolib.source.extend(['src/linux/{0}.cpp'.format(x) for x in [
            'linuxCap',
            'linuxNet',
            'linuxRouteMgr',
        ]])
        if ctx.env.HAVE_NETFILTER_QUEUE:
            protolib.source.append('src/linux/linuxDetour.cpp')
            protolib.use.append('NETFILTER_QUEUE')

    if system in ('darwin', 'freebsd', 'gnu/kfreebsd'):
        protolib.source.extend(['src/bsd/{0}.cpp'.format(x) for x in [
            'bsdDetour',
            'bsdRouteMgr',
        ]])
        if system != 'gnu/kfreebsd':
            protolib.source.append('src/bsd/bsdNet.cpp')
        protolib.source.append('src/unix/bpfCap.cpp')

    if system == 'windows':
        protolib.source.extend(['src/win32/{0}.cpp'.format(x) for x in [
            'win32Net',
            'win32RouteMgr',
        ]])
        
    if system == 'gnu':
        protolib.source.append('src/common/pcapCap.cpp')

    # Only add wxWidgets support if we have the libraries installed
    if ctx.env.HAVE_WX:
        protolib.source.append('src/wx/wxProtoApp.cpp')
        protolib.use.append('WX')

    # Language bindings
    if ctx.env.BUILD_PYTHON:
        ctx.shlib(
            features = 'pyext',
            target = 'protokit',
            name = 'pyprotokit',
            use = ['protolib'],
            source = ['src/python/protokit.cpp'],
        )

    if ctx.env.BUILD_JAVA:
        ctx.shlib(
            target = 'ProtolibJni',
            use = ['protolib', 'JAVA'],
            source = ['src/java/protoPipeJni.cpp'],
        )
        ctx(
            features = ['javac', 'jar'],
            srcdir = 'src/java/src',
            outdir = 'src/java/src',
            basedir = 'src/java/src',
            destfile = 'protolib-jni.jar',
        )

    # Example programs to build (not built by default, see below).
    for example in (
            'base64Example',
            'detourExample',
            'eventExample',
            'graphExample',
            'graphRider',
            'lfsrExample',
            'msg2MsgExample',
            'msgExample',
            'netExample',
            'pcapExample',
            'pipe2SockExample',
            'pipeExample',
            'protoCapExample',
            'protoExample',
            'protoFileExample',
            'queueExample',
            'serialExample',
            'simpleTcpExample',
            'sock2PipeExample',
            'threadExample',
            'timerTest',
            'vifExample',
            'vifLan',
            'wxProtoExample',
            'udptest'
            ):
        _make_simple_example(ctx, example)

    # Enable example targets specified on the command line
    ctx._parse_targets()

def _make_simple_example(ctx, name):
    '''Makes a task from a single source file in the examples directory.

    These tasks are not built by default.  Use the --targets flag.
    '''
    ctx.program(
        target = name,
        use = ['protolib'],
        stlib = ['protolib'],
        source = ['examples/{0}.cpp'.format(name)],
        # Don't build examples by default
        posted = True,
        # Don't install examples
        install_path = False,
    )

# Attach this method to the build context
@waflib.Configure.conf
def _parse_targets(ctx):
    '''Explicitly enable any targets (examples) set on the command line.

    See the "waf list" command and "waf --targets=target1,target2"
    Use --targets=* to build all examples
    '''
    for task in ctx.get_group(None):
        if ctx.targets == '*' or task.target in ctx.targets.split(','):
            task.posted = False

=== protolib/makefiles/android/protokit/lib/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.4.1)

add_definitions("-DANDROID=1" "-DANDROID_API_VERSION=10" "-DANDROID_ACTIVITY_CLASSNAME=mil_navy_nrl_protokit_protokit" "-DANDROID_ACTIVITY_CLASSPATH=\"mil/navy/nrl/protokit/protokit\"" "-DANDROID_SHARING_CONTENT_PROVIDER_CLASSNAME=mil_navy_nrl_protokit_SharingContentProvider" "-DANDROID_SHARING_CONTENT_PROVIDER_CLASSPATH=\"mil/navy/nrl/protokit/SharingContentProvider\"" "-DPUSH_NOTIFICATIONS=1" "-DANDROID" "-DLINUX" "-DUNIX" "-DHAVE_IPV6" "-DHAVE_DIRFD" "-DPROTO_DEBUG" "-DHAVE_ASSERT" "-DHAVE_GETLOGIN" "-DUSE_SELECT" "-D_FILE_OFFSET_BITS=64" "-DHAVE_OLD_SIGNALHANDLER" "-DHAVE_SCHED" "-DNO_SCM_RIGHTS" "-DAPP_VERSION=1.0.0" "-DAPP_VERSION_HEX=0x10000")

include_directories( AFTER
    "../../OID_NDK}/sources/android/cpufeatures"
    "../../../../include"
)

enable_language(ASM)

IF(BUILD_CONFIGURATION MATCHES "DEBUG")
    SET(BINARY_NAME "protokit")
    add_definitions("-DDEBUG=1" "-D_DEBUG=1")
ELSEIF(BUILD_CONFIGURATION MATCHES "RELEASE")
    SET(BINARY_NAME "protokit")
    add_definitions("-DNDEBUG=1")
ELSE(BUILD_CONFIGURATION MATCHES "DEBUG")
    MESSAGE( FATAL_ERROR "No matching build-configuration found." )
ENDIF(BUILD_CONFIGURATION MATCHES "DEBUG")

add_library( ${BINARY_NAME}

    STATIC

    "../../../../src/manet/manetGraph.cpp"
    "../../../../src/manet/manetMsg.cpp"
    "../../../../src/common/protoAddress.cpp"
    "../../../../src/common/protoApp.cpp"
    "../../../../src/common/protoBase64.cpp"
    "../../../../src/common/protoBitmask.cpp"
    "../../../../src/common/protoCap.cpp"
    "../../../../src/common/protoChannel.cpp"
    "../../../../src/common/protoCheck.cpp"
    "../../../../src/common/protoDebug.cpp"
    "../../../../src/common/protoDispatcher.cpp"
    "../../../../src/common/protoEvent.cpp"
    "../../../../src/common/protoFile.cpp"
    "../../../../src/common/protoGraph.cpp"
    "../../../../src/common/protoJson.cpp"
    "../../../../src/common/protoLFSR.cpp"
    "../../../../src/common/protoList.cpp"
    "../../../../src/common/protoNet.cpp"
    "../../../../src/common/protoPipe.cpp"
    "../../../../src/common/protoPkt.cpp"
    "../../../../src/common/protoPktARP.cpp"
    "../../../../src/common/protoPktETH.cpp"
    "../../../../src/common/protoPktIGMP.cpp"
    "../../../../src/common/protoPktIP.cpp"
    "../../../../src/common/protoPktRIP.cpp"
    "../../../../src/common/protoPktRTP.cpp"
    "../../../../src/common/protoPktTCP.cpp"
    "../../../../src/common/protoQueue.cpp"
    "../../../../src/common/protoRouteMgr.cpp"
    "../../../../src/common/protoRouteTable.cpp"
    "../../../../src/common/protoSocket.cpp"
    "../../../../src/common/protoSpace.cpp"
    "../../../../src/common/protoString.cpp"
    "../../../../src/common/protoTime.cpp"
    "../../../../src/common/protoTimer.cpp"
    "../../../../src/common/protoTree.cpp"
    "../../../../src/common/protoVif.cpp"
    "../../../../src/unix/unixNet.cpp"
    "../../../../src/unix/unixVif.cpp"
)


find_library(log "log")
find_library(android "android")
find_library(glesv2 "GLESv2")
find_library(egl "EGL")

target_link_libraries( ${BINARY_NAME}

    ${log}
    ${android}
    ${glesv2}
    ${egl}
    "cpufeatures"
)

=== debian/changelog ===
norm (1.5.8+dfsg2-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:51:46 +0100

norm (1.5.8+dfsg2-2) unstable; urgency=medium

  * Add waf-python3.patch to convert the build system to python3,
    and change the build-dependency accordingly. (Closes: #937155)
  * Bump Standards-Version to 4.4.0, no changes.

 -- Luca Boccassi <bluca@debian.org>  Sat, 31 Aug 2019 17:20:41 +0100

norm (1.5.8+dfsg2-1) unstable; urgency=medium

  * Repack to remove additional Java pre-built binaries that sneaked
    into the latest version from the source.
  * Add support for "terse" DEB_BUILD_OPTIONS flag.
  * Add dependency libnorm-dev -> libpcap-dev and related pkg-config
    Libs.private flag on Hurd.
  * Bump Standards-Version to 4.2.1.

 -- Luca Boccassi <bluca@debian.org>  Mon, 17 Dec 2018 15:21:27 +0000

=== debian/control ===
Source: norm
Section: libs
Priority: optional
Maintainer: Luca Boccassi <bluca@debian.org>
Standards-Version: 4.4.0
Build-Depends: debhelper (>= 9), python3, libpcap-dev [hurd-i386],
Homepage: https://www.nrl.navy.mil/itd/ncs/products/norm

Package: libnorm1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: NACK-Oriented Reliable Multicast (NORM) library
 The NORM protocol is designed to provide end-to-end reliable transport of
 bulk data objects or streams over generic IP multicast routing and forwarding
 services.
 libnorm provides a shared library and an API to use such protocol.

Package: libnorm-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Suggests: libnorm-doc
Depends: ${misc:Depends}, libnorm1 (= ${binary:Version}),
         libpcap-dev [hurd-i386],
Description: NACK-Oriented Reliable Multicast (NORM) library
 The NORM protocol is designed to provide end-to-end reliable transport of
 bulk data objects or streams over generic IP multicast routing and forwarding
 services.
 libnorm provides a shared library and an API to use such protocol.
 .
 This package provides the development files for norm.

Package: libnorm-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: dwww | dhelp | doc-central
Depends: ${misc:Depends},
Description: NACK-Oriented Reliable Multicast (NORM) library
 The NORM protocol is designed to provide end-to-end reliable transport of
 bulk data objects or streams over generic IP multicast routing and forwarding
 services.
 libnorm provides a shared library and an API to use such protocol.
 .
 This package provides the documentation and examples for norm.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

# For DEB_HOST_MULTIARCH and DEB_VERSION_UPSTREAM
include /usr/share/dpkg/default.mk

# On older distros +pie will add -fPIE -pie to the library linkage, which breaks
# it, -fPIC is enough
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
	WAF = python3 ./waf -v
else
	WAF = python3 ./waf
endif

ifneq (,$(filter hurd,$(DEB_HOST_ARCH_OS)))
        STATIC_LIBS="-lpcap"
else
        STATIC_LIBS=""
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	$(WAF) configure --prefix=/usr --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_build:
	$(WAF) build --enable-static-library

override_dh_auto_install:
	$(WAF) install --destdir=$(CURDIR)/debian/tmp --enable-static-library
	install -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	sed -e "s/@VERSION@/$(DEB_VERSION_UPSTREAM)/" \
                -e "s|@DEB_HOST_MULTIARCH@|$(DEB_HOST_MULTIARCH)|g" \
                -e "s|@STATIC_LIBS@|$(STATIC_LIBS)|g" \
                debian/norm.pc.in > \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/norm.pc

override_dh_auto_clean:
	$(WAF) distclean
	find waflib -name "*.pyc" -delete

## norm 1.5.9%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
		-DNORM_CUSTOM_PROTOLIB_VERSION=./protolib \
		-DBUILD_SHARED_LIBS=ON -DBUILD_STATIC_LIBS=ON

## norm 1.5.9+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
cmake_policy(SET CMP0077 NEW)

# set the project name
project(protokit)

set(COMMON src/common)

option(PROTOKIT_BUILD_EXAMPLES "Enables building of the examples in /examples." OFF)
option(PROTOKIT_BUILD_PYTHON "Enables building of python bindings **NOT IMPLEMENTED**." OFF)
option(PROTOKIT_BUILD_JAVA "Enables building of jave bindings **NOT IMPLEMENTED**." OFF)
option(PROTOKIT_ENABLE_DEBUG "Include debugging messages/logging **NOT IMPLEMENTED**." OFF)
option(PROTOKIT_ENABLE_WX "Enables building with WX Widgets" OFF)
option(PROTOKIT_ENABLE_INSTALL "Enables install target" OFF)

# Availability checks
include(CheckCXXSymbolExists)
include(CheckStructHasMember)
include(CheckTypeSize)
include(CheckIncludeFiles)
include(CheckLibraryExists)

check_include_files( pcap.h HAVE_PCAP_H)
if(HAVE_PCAP_H)
	#list(APPEND PLATFORM_SOURCE_FILES ${COMMON}/pcapCap.cpp)
endif()

check_include_files( sys/timerfd.h HAVE_TIMERFD_H)
if(HAVE_TIMERFD_H)
	list(APPEND PLATFORM_DEFINITIONS USE_TIMERFD)
endif()

check_include_files( sys/select.h HAVE_SELECT_H)
check_include_files( sys/epoll.h HAVE_EPOLL_H)
if(HAVE_EPOLL_H)
	list(APPEND PLATFORM_DEFINITIONS USE_EPOLL)
	message(STATUS "Using epoll")
elseif(HAVE_SELECT_H)
	list(APPEND PLATFORM_DEFINITIONS USE_SELECT)
	message(STATUS "Using select")
else()
	message(STATUS "Using neither epoll or select")
endif()

check_cxx_symbol_exists( sched_setscheduler "sched.h" HAVE_SCHED_SETSCHEDULER )
if(HAVE_SCHED_SETSCHEDULER)
	list(APPEND PLATFORM_DEFINITIONS HAVE_SCHED)
endif()

check_cxx_symbol_exists(assert "assert.h" HAVE_ASSERT)
if(HAVE_ASSERT)
	list(APPEND PLATFORM_DEFINITIONS HAVE_ASSERT)
endif()

check_cxx_symbol_exists(lockf "unistd.h" HAVE_LOCKF)
if(HAVE_LOCKF)
	list(APPEND PLATFORM_DEFINITIONS HAVE_LOCKF)
endif()

check_cxx_symbol_exists(flock "sys/file.h" HAVE_FLOCK)
if(HAVE_FLOCK)
	list(APPEND PLATFORM_DEFINITIONS HAVE_FLOCK)
endif()

check_cxx_symbol_exists(eventfd "sys/eventfd.h" HAVE_EVENTFD) #USE
if(HAVE_EVENTFD)
	list(APPEND PLATFORM_DEFINITIONS USE_EVENTFD)
endif()

check_cxx_symbol_exists(pselect "sys/select.h" HAVE_PSELECT)
if(HAVE_PSELECT)
	list(APPEND PLATFORM_DEFINITIONS HAVE_PSELECT)
endif()

check_struct_has_member(sockaddr_un sun_len "sys/un.h" HAVE_SUN_LEN)
if(NOT HAVE_SUN_LEN)
	list(APPEND PLATFORM_DEFINITIONS NO_SCM_RIGHTS)
endif()

check_cxx_symbol_exists(in6addr_any "netinet/in.h" HAVE_IPV6)
if(HAVE_IPV6)
    list(APPEND PLATFORM_DEFINITIONS HAVE_IPV6)
endif()

# Check for libraries
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
find_package(LibXml2)
if(LibXml2_FOUND)
	include_directories(${LIBXML2_INCLUDE_DIR})
	list(APPEND PLATFORM_LIBS ${LIBXML2_LIBRARIES})
	list(APPEND PUBLIC_HEADER_FILES include/protoXml.h)
	list(APPEND COMMON_SOURCE_FILES ${COMMON}/protoXml.cpp)
endif()

if(PROTOKIT_ENABLE_WX)
        find_package(wxWidgets REQUIRED COMPONENTS core base)
	if(wxWidgets_FOUND)
		include(${wxWidgets_USE_FILE})
		list(APPEND PLATFORM_LIBS ${wxWidgets_LIBRARIES})
		list(APPEND PLATFORM_SOURCE_FILES src/wx/wxProtoApp.cpp)
	endif()
endif()

# List header files
list(APPEND PUBLIC_HEADER_FILES
include/manetGraph.h        
include/manetGraphML.h      
include/manetMsg.h          
include/ns3ProtoSimAgent.h  
include/protoAddress.h      
include/protoApp.h          
include/protoAverage.h      
include/protoBase64.h       
include/protoBitmask.h      
include/protoCap.h          
include/protoChannel.h     
include/protoCheck.h     
include/protoDebug.h       
include/protoDefs.h        
include/protoDetour.h      
include/protoDispatcher.h  
include/protoEvent.h       
include/protoFile.h        
include/protoGraph.h       
include/protoJson.h        
include/protoLFSR.h        
include/protoList.h     
include/protoNet.h      
include/protoNotify.h   
include/protoPipe.h     
include/protoPkt.h      
include/protoPktARP.h   
include/protoPktETH.h   
include/protoPktIGMP.h  
include/protoPktIP.h    
include/protoPktRIP.h   
include/protoPktRTP.h   
include/protoPktTCP.h      
include/protoQueue.h       
include/protoRouteMgr.h    
include/protoRouteTable.h  
include/protoSerial.h      
include/protoSimAgent.h    
include/protoSocket.h      
include/protoSpace.h       
include/protoString.h
include/protoTime.h
include/protoTimer.h
include/protoTree.h
include/protoVersion
include/protoVif.h
include/protokit.h
include/testFuncs.h
include/wxProtoApp.h
include/unix/zebraRouteMgr.h
)

# List platform-independent source files
list(APPEND COMMON_SOURCE_FILES 
          ${COMMON}/protoAddress.cpp  
		  ${COMMON}/protoApp.cpp 
		  ${COMMON}/protoBase64.cpp 
          ${COMMON}/protoBitmask.cpp 
		  ${COMMON}/protoCap.cpp 
		  ${COMMON}/protoChannel.cpp 
		  ${COMMON}/protoDebug.cpp 
		  ${COMMON}/protoDispatcher.cpp 
		  ${COMMON}/protoEvent.cpp 
          ${COMMON}/protoFile.cpp 
		  ${COMMON}/protoGraph.cpp 
		  ${COMMON}/protoJson.cpp 
		  ${COMMON}/protoLFSR.cpp 
		  ${COMMON}/protoList.cpp 
          ${COMMON}/protoNet.cpp 
          ${COMMON}/protoPipe.cpp 
          ${COMMON}/protoPkt.cpp 
		  ${COMMON}/protoPktARP.cpp 
		  ${COMMON}/protoPktETH.cpp 
		  ${COMMON}/protoPktIGMP.cpp 
		  ${COMMON}/protoPktIP.cpp 
		  ${COMMON}/protoPktRTP.cpp 
		  ${COMMON}/protoQueue.cpp 
          ${COMMON}/protoRouteMgr.cpp 
		  ${COMMON}/protoRouteTable.cpp 
          ${COMMON}/protoSerial.cpp 
		  ${COMMON}/protoSocket.cpp 
          ${COMMON}/protoSpace.cpp 
		  ${COMMON}/protoString.cpp
          ${COMMON}/protoTime.cpp 
		  ${COMMON}/protoTimer.cpp 
          ${COMMON}/protoTree.cpp 
          ${COMMON}/protoVif.cpp )

# Setup platform independent include directory
list(APPEND INCLUDE_DIRS ${CMAKE_CURRENT_LIST_DIR}/include )

# Setup platform dependent libraries, defines, source file and compiler flags
if(MSVC)
	list(APPEND PLATFORM_LIBS ws2_32 iphlpapi user32 gdi32 Advapi32 ntdll)
	list(APPEND PLATFORM_DEFINITIONS _CRT_SECURE_NO_WARNINGS)
	list(APPEND PLATFORM_SOURCE_FILES src/win32/win32Net.cpp src/win32/win32RouteMgr.cpp)
	list(APPEND PLATFORM_FLAGS /EHsc)
elseif(UNIX)
	list(APPEND PLATFORM_DEFINITIONS UNIX _FILE_OFFSET_BITS=64)
	list(APPEND PLATFORM_LIBS pthread)
	list(APPEND PLATFORM_SOURCE_FILES 	src/unix/unixNet.cpp 
										src/unix/unixSerial.cpp 
										src/unix/unixVif.cpp
										src/manet/manetGraph.cpp
										src/manet/manetMsg.cpp)
	if(${CMAKE_SYSTEM_NAME} STREQUAL Linux)
		list(APPEND PLATFORM_DEFINITIONS LINUX )
		list(APPEND PLATFORM_LIBS dl rt)
		list(APPEND PLATFORM_SOURCE_FILES 	src/linux/linuxCap.cpp 
										    src/linux/linuxNet.cpp 
										    src/linux/linuxRouteMgr.cpp
										    src/unix/zebraRouteMgr.cpp)
		
		check_library_exists(netfilter_queue pktb_alloc "" HAVE_NETFILTER_QUEUE)
		if(HAVE_NETFILTER_QUEUE)
			list(APPEND PLATFORM_LIBS NETFILTER_QUEUE)
			list(APPEND PLATFORM_SOURCE_FILES src/linux/linuxDetour.cpp)
			list(APPEND examples detourExample)
		endif()
	elseif(${CMAKE_SYSTEM_NAME} STREQUAL Darwin )
		list(APPEND PLATFORM_DEFINITIONS MACOSX )
		list(APPEND PLATFORM_SOURCE_FILES 	src/bsd/bsdDetour.cpp
											src/bsd/bsdRouteMgr.cpp
											src/bsd/bsdNet.cpp
											src/unix/bpfCap.cpp)
            SET(CMAKE_C_ARCHIVE_CREATE   "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
            SET(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
            SET(CMAKE_C_ARCHIVE_FINISH   "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
            SET(CMAKE_CXX_ARCHIVE_FINISH "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
	endif()
endif()

include(GNUInstallDirs)

# Setup target

add_library(protokit STATIC ${PLATFORM_SOURCE_FILES} ${COMMON_SOURCE_FILES} ${PUBLIC_HEADER_FILES})
add_library(protokit::protokit ALIAS protokit)
target_link_libraries(protokit PRIVATE ${PLATFORM_LIBS})
target_compile_definitions(protokit PUBLIC ${PLATFORM_DEFINITIONS})
target_compile_options(protokit PUBLIC ${PLATFORM_FLAGS})
target_include_directories(protokit PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories(protokit PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)

# Install target
if(${PROTOKIT_ENABLE_INSTALL})
	install( TARGETS protokit EXPORT protokitTargets
			RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} )

	install( EXPORT protokitTargets
		FILE protokitConfig.cmake
		NAMESPACE protokit::
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/protokit
	)

	install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

	export(EXPORT protokitTargets
		FILE ${CMAKE_CURRENT_BINARY_DIR}/protokitTargets.cmake
		NAMESPACE protokit::)
		
	export(PACKAGE protokit)
endif()

if(PROTOKIT_BUILD_EXAMPLES)
	# Setup examples
	list(APPEND examples 
	base64Example
	# detourExample This depends on netfilterqueue so doesn't work as a "simple example"
	eventExample
	fileTest
	graphExample
	#'graphRider', (this depends on manetGraphML.cpp so doesn't work as a "simple example"
	lfsrExample
	msg2MsgExample
	#'msgExample',  (this depends on examples/testFuncs.cpp so doesn't work as a "simple example"
	netExample
	pipe2SockExample
	pipeExample
	protoCapExample
	protoExample
	protoFileExample
	queueExample
	serialExample
	simpleTcpExample
	sock2PipeExample
	threadExample
	timerTest
	vifExample
	vifLan
	#'wxProtoExample', (this depends on wxWidgets (could use wx-config to test) so doesn't work as a "simple example"
	udptest)

	foreach(example ${examples})
		add_executable(${example} examples/${example}.cpp)
		target_link_libraries(${example} PRIVATE protokit)
		include_directories(${CMAKE_SOURCE_DIR}/include)
	endforeach()
endif()

=== debian/changelog ===
norm (1.5.9+dfsg-4) unstable; urgency=medium

  * d/rules: add -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to fix FTBFS with
    CMake 4 (Closes: #1113330)
  * Switch to pkgconf
  * d/control: bump Standards-Version to 4.7.2, no changes
  * Fix norm.pc's Libs.private (Closes: #1076813)

 -- Luca Boccassi <bluca@debian.org>  Mon, 13 Oct 2025 15:46:55 +0100

norm (1.5.9+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063179

 -- Benjamin Drung <bdrung@debian.org>  Fri, 01 Mar 2024 12:39:50 +0000

norm (1.5.9+dfsg-3) unstable; urgency=medium

  [ Samuel Thibault ]
  * d/control: Generalize hurd-i386 into hurd-any.

  [ Patrice Duroux ]
  * Update d/watch (Closes: #1051151)

  [ Luca Boccassi ]
  * Bump Standards-Version to 4.6.2, no changes
  * Bump copyright year ranges in d/copyright
  * Bump debhelper-compat to 13
  * Add symlinks to guides html to fix Lintian errors

 -- Luca Boccassi <bluca@debian.org>  Mon, 01 Jan 2024 20:50:27 +0100

norm (1.5.9+dfsg-2) unstable; urgency=medium

  * Add build dependency on pkg-config

 -- Luca Boccassi <bluca@debian.org>  Mon, 15 Feb 2021 14:04:32 +0000

norm (1.5.9+dfsg-1) unstable; urgency=medium

  * Add Vcs fields, pointing to Salsa
  * Bump Standards-Version to 4.5.0, no changes
  * Update upstream source references to new Github repository
  * Switch to CMake and new Github layout
  * New upstream version 1.5.9
  * Build with CMake
  * Bump Standards-Version to 4.5.1, no changes
  * Set Rules-Requires-Root
  * Add new symbols from 1.5.9
  * Add debian/upstream metadata
  * Update short descriptions

 -- Luca Boccassi <bluca@debian.org>  Sun, 31 Jan 2021 16:58:39 +0000

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,17 @@
 Section: libs
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
-Standards-Version: 4.4.0
-Build-Depends: debhelper (>= 9), python3, libpcap-dev [hurd-i386],
+Standards-Version: 4.7.2
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13), cmake, libpcap-dev [hurd-any], libxml2-dev, pkgconf,
 Homepage: https://www.nrl.navy.mil/itd/ncs/products/norm
+Vcs-Browser: https://salsa.debian.org/debian/norm
+Vcs-Git: https://salsa.debian.org/debian/norm.git
 
-Package: libnorm1
+Package: libnorm1t64
+Provides: ${t64:Provides}
+Replaces: libnorm1
+Breaks: libnorm1 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -22,9 +28,10 @@
 Architecture: any
 Multi-Arch: same
 Suggests: libnorm-doc
-Depends: ${misc:Depends}, libnorm1 (= ${binary:Version}),
-         libpcap-dev [hurd-i386],
-Description: NACK-Oriented Reliable Multicast (NORM) library
+Depends: ${misc:Depends}, libnorm1t64 (= ${binary:Version}),
+         libpcap-dev [hurd-any],
+         libxml2-dev,
+Description: NACK-Oriented Reliable Multicast (NORM) library (development files)
  The NORM protocol is designed to provide end-to-end reliable transport of
  bulk data objects or streams over generic IP multicast routing and forwarding
  services.
@@ -38,7 +45,7 @@
 Multi-Arch: foreign
 Recommends: dwww | dhelp | doc-central
 Depends: ${misc:Depends},
-Description: NACK-Oriented Reliable Multicast (NORM) library
+Description: NACK-Oriented Reliable Multicast (NORM) library (documentation)
  The NORM protocol is designed to provide end-to-end reliable transport of
  bulk data objects or streams over generic IP multicast routing and forwarding
  services.

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg,filenamemangle=s/(?:.*?)@ANY_VERSION@(@ARCHIVE_EXT@)/@PACKAGE@-$1$2/ \
 https://github.com/USNavalResearchLaboratory/@PACKAGE@/tags (?:.*?/)@ANY_VERSION@@ARCHIVE_EXT@
